# Visualization Library A lightweight C++ OpenGL middleware for 2D/3D graphics | [Home] [Tutorials] [All Classes] [Grouped Classes]

# vl::Say Class Reference

A simple String formatting class. More...

`#include <Say.hpp>`

List of all members.

## Public Member Functions
| Say (const String &fstr)
Say & | operator<< (const SayArg &p)
template<typename T >
Say & | operator<< (T p)
| operator String ()
String | str () const
## Public Attributes
String | format_string
## Protected Member Functions
String | parse (const Say &pset) const
String | euronotation (const String &str, int base) const
String | format (unsigned long long n, int base, int field, int decimals, int align, unsigned short fill, int plus, int finalizer, int eur) const
String | format (signed long long nn, int base, int field, int decimals, int align, unsigned short fill, int plus, int finalizer, int eur) const
String | format (double num, int base, int field, int decimals, int align, unsigned short fill, int plus, int finalizer, int eur) const
String | pipeline (const String &str, int base, int field, int decimals, int finalizer, int align, int eur, unsigned short fill, int negative, int plus) const

## Detailed Description

A simple String formatting class.

Remarks:
  Things that we cannot do:
  - Exponential rounding
  - Explicit parameter reference
  - Dynamic field and decimal length

Things we can do:

- Handles: String, char*, signed/unsigned char/short/int/long long, float, double
- Shows both integer and fractional numbers in the following bases 2, 8, 10, 16 (actually any base between 2 and 16 but the parser knows only these 4)
- Field size
- Field alignment
- "+" Sign
- Decimal field size with rounding (only for normal notation for now)
- Uppercase and lowercase output
- "Euro" notation ouput for numbers
- Normal and exponential notation
- Clear and helpful debugging messages
- Typesafe, portable, easy to use, clean

## Constructor & Destructor Documentation

vl::Say::Say | ( | const String & | fstr | ) | `[inline]`

## Member Function Documentation

Say& vl::Say::operator<< | ( | const SayArg & | p | ) | `[inline]`

template<typename T >

Say& vl::Say::operator<< | ( | T | p | ) | `[inline]`

vl::Say::operator String | ( |  | ) | `[inline]`

String vl::Say::str | ( |  | ) | const`[inline]`

String Say::parse | ( | const Say & | pset | ) | const`[protected]`

String Say::euronotation | ( | const String & | str,
|  | int | base |
| ) |  |  | const`[protected]`

String Say::format | ( | unsigned long long | n,
|  | int | base,
|  | int | field,
|  | int | decimals,
|  | int | align,
|  | unsigned short | fill,
|  | int | plus,
|  | int | finalizer,
|  | int | eur |
| ) |  |  | const`[protected]`

String Say::format | ( | signed long long | nn,
|  | int | base,
|  | int | field,
|  | int | decimals,
|  | int | align,
|  | unsigned short | fill,
|  | int | plus,
|  | int | finalizer,
|  | int | eur |
| ) |  |  | const`[protected]`

String Say::format | ( | double | num,
|  | int | base,
|  | int | field,
|  | int | decimals,
|  | int | align,
|  | unsigned short | fill,
|  | int | plus,
|  | int | finalizer,
|  | int | eur |
| ) |  |  | const`[protected]`

String Say::pipeline | ( | const String & | str,
|  | int | base,
|  | int | field,
|  | int | decimals,
|  | int | finalizer,
|  | int | align,
|  | int | eur,
|  | unsigned short | fill,
|  | int | negative,
|  | int | plus |
| ) |  |  | const`[protected]`

## Member Data Documentation

String vl::Say::format_string

The documentation for this class was generated from the following files:

- E:/VisualizationLibrary/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vl/Say.hpp
- E:/VisualizationLibrary/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vl/Say.cpp

Visualization Library v2009.08 Reference Documentation
Copyright 2005-2009 Michele Bosi. All rights reserved.
Updated on Sun Nov 8 14:29:03 2009.
Permission is granted to use this page to write and publish articles regarding Visualization Library.